
#include <windows.h>  
#include "findtext.h"  


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

HWND      hwndFind = NULL;

LPCTSTR lpszAppName = "MyApp";
LPCTSTR lpszTitle   = "FindText()/ReplaceText()"; 


BOOL RegisterWin95( CONST WNDCLASS* lpwc );


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon (hInstance, lpszAppName); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      if ( hwndFind && IsDialogMessage( hwndFind, &msg ) )
         continue;

      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

#define MAX_FIND_LEN  80

LPCTSTR lpszText = "This is a sample of text that can be searched using the"\
                   " Find Text or Replace Text common dialog box.";


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static FINDREPLACE fr;
static char        szFind[MAX_FIND_LEN+1];
static char        szReplace[MAX_FIND_LEN+1];
static char        szBuf[512];
static char        szNewBuf[512];

static UINT        uFindMessage = 0;
static HWND        hEdit        = NULL;
static DWORD       dwPos        = 0;


   // Handle Find and Replace common dialog message.
   //...............................................
   if ( uMsg == uFindMessage )
   {
      LPFINDREPLACE lpfr = (LPFINDREPLACE)lParam;

      // Handle the Find Next command.
      //..............................
      if ( lpfr->Flags & FR_FINDNEXT )
      {
         LPTSTR lpFound;
         DWORD  dwCurPos = SendMessage( hEdit, EM_GETSEL, 0, 0 );

         // If the position is the same as where we were,
         // increment the position sow we find the next string.
         //....................................................
         if ( LOWORD(dwCurPos) == dwPos && dwPos > 0 )
            dwPos++;
         else
            dwPos = LOWORD( dwCurPos );
         
         SendMessage( hEdit, WM_GETTEXT, sizeof( szBuf ), (LPARAM)szBuf );

         // Find the search string within the text starting at the 
         // current cursor position within the edit control.
         //.......................................................
         lpFound = strstr( &szBuf[ LOWORD(dwPos) ], lpfr->lpstrFindWhat );

         // If the text was found, highlight it.
         //.....................................
         if ( lpFound )
         {
            dwPos = lpFound-&szBuf[0];
            SendMessage( hEdit, EM_SETSEL, dwPos, 
                         strlen( lpfr->lpstrFindWhat )+dwPos );
         }
         else
            MessageBox( hWnd, "The string was not found.", 
                              "Find", MB_OK | MB_ICONINFORMATION );
      }

      // Handle the Replace command.
      //............................
      if ( lpfr->Flags & FR_REPLACE )
      {
         SendMessage( hEdit, WM_GETTEXT, sizeof( szBuf ), (LPARAM)szBuf );

         szBuf[dwPos] = 0;
         strcpy( szNewBuf, szBuf );
         strcat( szNewBuf, lpfr->lpstrReplaceWith );
         strcat( szNewBuf, &szBuf[strlen( lpfr->lpstrFindWhat )+dwPos] );

         SendMessage( hEdit, WM_SETTEXT, 0, (LPARAM)szNewBuf );
         SendMessage( hEdit, EM_SETSEL, dwPos, 
                      strlen( lpfr->lpstrReplaceWith )+dwPos );
      }

      // Handle the Replace All command.
      //................................
      if ( lpfr->Flags & FR_REPLACEALL )
         MessageBox( hWnd, "Replace All is not implemented.", 
                           "Replace", MB_OK | MB_ICONINFORMATION );

      // If the dialog is terminating, set the handle to NULL.
      //......................................................
      if ( lpfr->Flags & FR_DIALOGTERM )
         hwndFind = NULL; 
   }

   switch( uMsg )
   {
      case WM_CREATE :
              memset( &fr, 0, sizeof( FINDREPLACE ) );

              uFindMessage = RegisterWindowMessage( "commdlg_FindReplace" );

              hEdit = CreateWindow( "EDIT", "",    
                                    WS_CHILD | ES_LEFT | 
                                    WS_VISIBLE | ES_MULTILINE | ES_NOHIDESEL, 
                                    0, 0, 
                                    0, 0,  
                                    hWnd,              
                                    (HMENU)101,              
                                    hInst,         
                                    NULL               
                                  );

              SendMessage( hEdit, WM_SETTEXT, 0, (LPARAM)lpszText );
              break;

      case WM_SIZE :
              MoveWindow( hEdit, 0, 0, LOWORD( lParam ), HIWORD( lParam ), TRUE );
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_FIND :
                        fr.lStructSize   = sizeof( FINDREPLACE ); 
                        fr.hwndOwner     = hWnd;
                        fr.lpstrFindWhat = szFind;
                        fr.wFindWhatLen  = MAX_FIND_LEN; 
                        fr.Flags         = FR_MATCHCASE | FR_HIDEUPDOWN | FR_HIDEWHOLEWORD;

                        hwndFind = FindText( &fr );
                        break;

                 case IDM_REPLACE :
                        fr.lStructSize      = sizeof( FINDREPLACE ); 
                        fr.hwndOwner        = hWnd;
                        fr.lpstrFindWhat    = szFind;
                        fr.lpstrReplaceWith = szReplace;
                        fr.wFindWhatLen     = MAX_FIND_LEN; 
                        fr.wReplaceWithLen  = MAX_FIND_LEN;
                        fr.Flags            = FR_MATCHCASE | FR_HIDEUPDOWN | FR_HIDEWHOLEWORD;

                        hwndFind = ReplaceText( &fr );
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;

      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
